#if C_GRAPHICSMEDIA_LAB_DMOROZ_C
#/*******************************************************************************
# * (C) Copyright 2003/2004 by Vladimir Vezhnevets <vvp@graphics.cs.msu.su>     *
# *******************************************************************************/
#endif

// MFC_GML3View.cpp : implementation of the CImageView class
//

#include "stdafx.h"
#include "MFC_GML3.h"

#include "MFC_GML3Doc.h"
#include "MFC_GML3View.h"
#include "Processing.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageView

IMPLEMENT_DYNCREATE(CImageView, CView)

BEGIN_MESSAGE_MAP(CImageView, CView)
	//{{AFX_MSG_MAP(CImageView)
	ON_COMMAND(ID_PROCESSING_1DHORIZONTALBOXFILTER, OnBoxfilter)
	ON_COMMAND(ID_PROCESSING_COLORIZE, OnProcessingColorize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageView construction/destruction

CImageView::CImageView()
{
	// TODO: add construction code here

}

CImageView::~CImageView()
{
}

BOOL CImageView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CImageView drawing

void CImageView::OnDraw(CDC* pDC)
{
	CImageDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

  ///       device context
  pDoc->Paint(pDC->m_hDC);
}

/////////////////////////////////////////////////////////////////////////////
// CImageView diagnostics

#ifdef _DEBUG
void CImageView::AssertValid() const
{
	CView::AssertValid();
}

void CImageView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CImageDoc* CImageView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CImageDoc)));
	return (CImageDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CImageView message handlers

unsigned char pcBuf[1024 * 1024];

void CImageView::OnBoxfilter() 
{
  ///     
  CImageDoc* pDoc = GetDocument();

  ///    (   ,  )
  DSimpleBitmap TempImage;

  ///     
  TempImage = pDoc->m_Image;
  
  /// 
  BoxFilter(&TempImage, &pDoc->m_Image);

  ///  
  Invalidate();
}

void CImageView::OnProcessingColorize() 
{
  ///     
  CImageDoc* pDoc = GetDocument();

  /// 
  Colorize(&pDoc->m_Image);

  ///  
  Invalidate();
}
